//battleSystem.js
//thanks go to NeoLogiX for his pseudo-skeleton
var bg1 = LoadImage("battlebg1.png");
var atb = LoadImage("atbGuage.png");

var winStyle1 = LoadWindowStyle("LoadBack.rws");
var winStyle2 = LoadWindowStyle("Purple.rws");
var winSelect = LoadWindowStyle("MenuRing.rws");
var winHelp = LoadWindowStyle("Help.rws");

var whiteFont = LoadFont("WeissKlein.rfn");
var normFont = LoadFont("talkfont.rfn");
var greenFont = LoadFont("green.rfn");
var trialFont = LoadFont("FRLGBattleD.rfn");
var redFont = LoadFont("Rot.rfn");

var screenshot;
var bmes = "Hey, does it work now?";
var messageShowingTime = 0;
var messageShowing = false;

var normAttack = [LoadImage("nAttack1.png"),LoadImage("nAttack2.png"),LoadImage("nAttack3.png")];
var normSound = LoadSound("punch6.wav");
var tackleS = LoadSound("strike10.wav");
var runSound = LoadSound("flee.wav");

var battleBGM = LoadSound("Battle.it");
var battleEnd = LoadSound("battleEnd.it");



var battleTimer = 0;

var whoYourAttacking;
var damageDealt;
var showHeroDamage = false;
var showDamLength = 0;

var howMuchDamage;
var showDamLength2 = 0;
var drawDamage = false;//for showing how much damage was done to the enemy

var damDone;//amount of damage done


function battle(enemyGroup,bg){
	lastSong.stop();
	battleBGM.play(true);
//initialize stuff for battle
	SetFrameRate(60);//set the frame rate to 60 frames per second [60:1]
	battleTimer = 0;//start the battle timer ;D
	var showingSelMenu = false;
	var actPlayer = 0;//ready player
	var heroChoice = 0;//menu choice
	var keyGotPressed = false; //used To Slow The Selection Menu
	var keyPressedLength = 0;
	var done = false;
	var updateTimers = true;
	var movl;
	var movr;
	var movw; //wait
	var anim = 0;
	showDamLength = 0;
	showDamLength2 = 0;
	var dead = false;
	var deadPause = 0;
	showHeroDamage = false;
	var lvl1 = false;
	var lvl2 = false;
	
	enemyGroup.pk1.hp = enemyGroup.pk1.maxhp;
	
	//reset everything before battle
	for(i=0;i<playerParty.length;i++){
		playerParty[i].atbCur = 0;
	}
	enemyGroup.atbCur = 0;
	
	
/////////////////////////////END INIT

//START OF MAIN LOOP//
	while(!done){
		//blit bg & underelements
		bg.blit(0,0);		
		
		//blit combatants and main elements
		
		if(!updateTimers){
			if(movl){
				if(playerParty[actPlayer].x > 190)playerParty[actPlayer].x --;
				else {movl = false;movw = 0;}
			}

				
			if(movw<60){
				movw++;
				if(movw == 60) movr = true;
				if(movw < 30)enemyGroup.pk1.x -=.25;
				if(movw > 30)enemyGroup.pk1.x +=.25;
			}
				
			if(movr){
				if(playerParty[actPlayer].x < 200)playerParty[actPlayer].x ++;
				else {movr = false; updateTimers = true;}
			}
		}
		
		
		for(i=0;i<playerParty.length;i++){
			playerParty[i].battlepic.blit(playerParty[i].x,playerParty[i].y);
		}
		enemyGroup.pk1.battlepic.blit(enemyGroup.pk1.x,enemyGroup.pk1.y);
		
		if(heroChoice == 0 && !updateTimers && movw < 60){
			
			if(anim > 20) normAttack[2].blit(23,23);
			else if(anim > 10) normAttack[1].blit(33,23);
			else normAttack[0].blit(43,23);
			anim ++;
			if(anim == 10)normSound.play(false);
				
		}
		else anim = 0;
		
		//show the damage done to the hero		
		if(showHeroDamage){
			enemyGroup.pk1.x += 1;
			
			if(showDamLength < 40 && enemyGroup.pk1.x >= 60){
				tackleS.play(false);
				playerParty[whoYourAttacking].battlepicwhite.blit(playerParty[whoYourAttacking].x,playerParty[whoYourAttacking].y);
				if(damageDealt == 0)
					redFont.drawText(playerParty[whoYourAttacking].x,playerParty[whoYourAttacking].y+(showDamLength/4),"Miss!");
				else redFont.drawText(playerParty[whoYourAttacking].x+10,playerParty[whoYourAttacking].y+(showDamLength/4),damageDealt);
				showDamLength++;
				enemyGroup.pk1.x = 60;
			}
			if(showDamLength>=40) {enemyGroup.pk1.x = 40;showHeroDamage = false;showDamLength=0;}
			
		}
			
		if(drawDamage){
			if(howMuchDamage == 0) redFont.drawText(enemyGroup.pk1.x,enemyGroup.pk1.y+showDamLength2,"Miss!");
			else redFont.drawText(enemyGroup.pk1.x+10,enemyGroup.pk1.y-(showDamLength2/4),howMuchDamage);
			
			if(showDamLength2 >= 40) {drawDamage = false; showDamLength2=0;}
			
			showDamLength2++;
		}
		
		
		//End of battle Stuff *I know it's a random place to place it but whatever.
		if(dead){
			if(deadPause == 155) {
				ShowMessage("You won the battle!",540);
				battleBGM.stop();
				battleEnd.play(true);
			}
			if(deadPause < 255)enemyGroup.pk1.battlepic.blitMask(enemyGroup.pk1.x,enemyGroup.pk1.y,CreateColor(255,0,0,deadPause));
			else enemyGroup.pk1.battlepic.blitMask(enemyGroup.pk1.x,enemyGroup.pk1.y,CreateColor(255,0,0));
			deadPause+=1;
			
			if(deadPause >= 600) {
				var itemRand = Math.random()*10;
				var e2g = enemyGroup.pk1.exp;
				var lu = false;
				while(!done){
					if(deadPause == 1020) {player.gold += enemyGroup.pk1.bits;done = true;battleEnd.stop();}
					deadPause++;
					if(deadPause > 720 && deadPause % 5 == 0 && e2g > 0){
						e2g --;
						for(i=0;i<playerParty.length;i++){
							playerParty[i].NeededExp --;
						}
					}
					
					winHelp.drawWindow(0,0,240,160);
					winHelp.drawWindow(10,10,100,20);
					whiteFont.drawText(16,12,"    EXP               " + e2g);
					winHelp.drawWindow(130,10,100,20);
					whiteFont.drawText(136,12,"   SAB              " + enemyGroup.pk1.NeededExp);//Implement later
					if(playerParty.length == 2){
						winHelp.drawWindow(10,50,100,50);
						winHelp.drawWindow(130,50,100,50);
						playerParty[0].picFlip.blit(12,52);
						playerParty[1].picFlip.blit(132,52);
						whiteFont.drawText(40,51,playerParty[0].name + "    Lv" + playerParty[0].lvl);
						whiteFont.drawText(162,51,playerParty[1].name + "    Lv" + playerParty[1].lvl);
						whiteFont.drawText(40,71,"Needed Exp.");
						whiteFont.drawText(162,71,"Needed Exp.");
						whiteFont.drawText(60,81,playerParty[0].NeededExp);
						whiteFont.drawText(182,81,playerParty[1].NeededExp);
						
						for(i=0;i<playerParty.length;i++){
							if(playerParty[i].NeededExp == 0){
								playerParty[i].lvl++;
								levelUp(i);
								if(i==0) {
									playerParty[0].NeededExp = playerParty[0].lvl*playerParty[0].lvl*4;
									lvl1 = true;
								}
								else {
									playerParty[1].NeededExp = playerParty[1].lvl*playerParty[1].lvl * 3;
									lvl2 = true;
								}
							
							}
						}
					}
					else{
						winHelp.drawWindow(70,50,100,50);
						playerParty[0].picFlip.blit(72,52);
						whiteFont.drawText(100,51,playerParty[0].name + "    Lv" + playerParty[0].lvl);
						whiteFont.drawText(100,71,"Needed Exp.");
						whiteFont.drawText(120,81,playerParty[0].NeededExp);
						
						if(playerParty[0].NeededExp == 0){
							playerParty[0].lvl++;
							levelUp(0);
							playerParty[0].NeededExp = playerParty[0].lvl*playerParty[0].lvl*4;
							lu = true;
						}
					
					}
					
					if(lu) redFont.drawText(100,61,"Level Up!");
					if(lvl1) redFont.drawText(40,61,"Level Up!");
					if(lvl2) redFont.drawText(162,61,"Level Up!");
					winHelp.drawWindow(10,120,100,20);
					whiteFont.drawText(16,122,"    Bits        " + enemyGroup.pk1.bits);
					winHelp.drawWindow(130,120,100,20);
					if(itemRand<6) whiteFont.drawText(132,122,"      No item found.");
					else whiteFont.drawText(132,122,"     Found Potion!");
					FlipScreen();
				}
			}
			
			
		}
		/////////////////////END END OF BATTLE STUFF__THIS WAS PRETTY LONG>>>>////	
				
		////////////////////////////////////END COMBAT BLIT
		
		//blit HUD, etc.
		winStyle1.drawWindow(-5,100,80,60);
		winStyle2.drawWindow(80,104,155,51);
		
		//stuff for showing messages
		if(messageShowingTime != 0){
			winStyle2.drawWindow(0,75,260,20);
			greenFont.drawText(5,75,bmes);
			messageShowingTime--;
		}
		
		whiteFont.drawText(5,112,enemyGroup.nameL1);
		whiteFont.drawText(5,122,enemyGroup.nameL2);
		whiteFont.drawText(5,132,enemyGroup.nameL3);
		
		for(i=0;i<playerParty.length;i++){
			normFont.drawText(81,(i*27)+105,playerParty[i].name);
			trialFont.drawText(110,(i*27)+98,"HP");
			greenFont.drawText(115,(i*27)+105,playerParty[i].hp + "/" + playerParty[i].maxhp);
			trialFont.drawText(160,(i*27)+98,"SP");
			greenFont.drawText(165,(i*27)+105,playerParty[i].sp + "/" + playerParty[i].maxsp);
			atb.blit(120,(i*27)+120);
			Rectangle(140,(i*27)+123,(playerParty[i].atbCur/playerParty[i].atbMax)*48,2,CreateColor(255,255,0));
		}
		
		//stuff for showing the menu if one persons ATB guage is full
		if(showingSelMenu&&updateTimers&&!dead){
		
			winSelect.drawWindow((actPlayer)+200,(actPlayer*25)+28,24,24);
		
			winStyle2.drawWindow(4,94,66,61);
			for(i=0;i<playerParty[actPlayer].menuChoices.length;i++){
				normFont.drawText(10,(i*12)+96,playerParty[actPlayer].menuChoices[i]);
			}
			winSelect.drawWindow(4,(heroChoice*12)+96,64,9);
			
			if(IsKeyPressed(KEY_UP)&&heroChoice>0&&keyPressedLength == 0){
				heroChoice--;
				keyPressedLength = 10;
			}
			if(IsKeyPressed(KEY_DOWN)&&heroChoice<playerParty[actPlayer].menuChoices.length-1&&keyPressedLength == 0){
				heroChoice++;
				keyPressedLength = 10;
			}
			if(IsKeyPressed(KEY_CTRL)&&keyPressedLength == 0){
				switch(heroChoice){
					case 0:
					updateTimers = false;
					movl = true;
					
					playerParty[actPlayer].atbCur = 0;
					showingSelMenu = false;
					keyPressedLength = 20;
					
					howMuchDamage = damageDealt = Math.floor(playerParty[actPlayer].atk + (Math.random()*playerParty[actPlayer].atk) - enemyGroup.pk1.def);
					enemyGroup.pk1.hp -= howMuchDamage;
					
					
					drawDamage = true;
					break;
					case playerParty[actPlayer].menuChoices.length-1:
						done = true;
						runSound.play(false);
						Delay(1000);
					break;
				} 
			}
		}
		
		///////////////////////////////////////END HUD BLIT
		screenshot = GrabImage(0,0,GetScreenWidth(),GetScreenHeight());
		
		FlipScreen();//display everything
		
		//EVENT HANDLING
		//atbGuageUpdate[enemy and player updated]
		
		
		for(i=0;i<playerParty.length;i++){
			if(playerParty[i].atbCur >= playerParty[i].atbMax && !showingSelMenu && updateTimers){
				showingSelMenu = true;
				actPlayer = i;
				break;
			}
		}
		
		for(i=0;i<playerParty.length;i++){
			if(playerParty[i].atbCur < playerParty[i].atbMax && updateTimers){
				playerParty[i].atbCur += playerParty[i].atbGrow;
			}
		}
		
		//stuff for enemies
		if(enemyGroup.pk1.atbCur < enemyGroup.pk1.atbMax && updateTimers){
			enemyGroup.pk1.atbCur += enemyGroup.pk1.atbGrow;
		}


		if(enemyGroup.pk1.atbCur >= enemyGroup.pk1.atbMax&&!dead){
			enemyGroup.pk1.atbCur = 0;
			whoYourAttacking = Math.floor(Math.random()*playerParty.length);
			damageDealt = Math.floor(enemyGroup.pk1.atk + (Math.random()*enemyGroup.pk1.atk) - playerParty[whoYourAttacking].def);
			if(damageDealt < 0)damageDealt = 0;
			playerParty[whoYourAttacking].hp -= damageDealt;
			showHeroDamage = true;
		}

		//End atbGuageUpdate
		if(updateTimers) battleTimer ++;
		if(keyPressedLength > 0){
			keyPressedLength --;
		}
		//////////////////////////////END OF EVENT HANDLING
		
		if(battleTimer == 1){
			ShowMessage(enemyGroup.openingMessage,120);
		}
		
		
		
		if(enemyGroup.pk1.hp <= 0) dead = true;
		
	}
	//END OF MAIN LOOP
	battleBGM.stop();

	lastSong.play(true);
}


function ShowMessage(what,howlong)
{
	messageShowingTime = howlong;
	bmes = what;
}
	