//heros.js

function character(name,hp,sp,atk,def,spd,lvl)
{
	this.name = name;
	this.maxhp = hp;
	this.hp = this.maxhp;
	this.maxsp = sp;
	this.sp = this.maxsp;
	this.atk = atk;
	this.def = def;
	this.spd = spd;
	this.lvl = lvl;
	
	this.atbMax = 300;
	this.atbGrow = (this.lvl/50)+(this.spd/255)+1;
	this.atbCur = 0;
	
	this.exp = 0;
	this.expToNext = 0;
	this.NeededExp = this.lvl*this.lvl*2;
	
	this.attacks = new Array();
	
	this.facepic;
	this.battlepic;
	this.battlepicwhite;
	this.picFlip;
	this.x;
	this.y;
	
	this.bits;
	
	this.menuChoices;
	
	this.enemy = false;
}

character.prototype.clone = function() {
	var obj = new character();
  for (var i in this)    
		obj[i] = this[i];  
  return obj;
}

var Heros = new Array();
Heros[0] = new character("Hiro", 50, 14, 9,10,11,1);
Heros[0].battlepic = LoadImage("Hiro.png");
Heros[0].battlepicwhite = LoadImage("HiroWhite.png");
Heros[0].picFlip = LoadImage("HiroFlipped.png");
Heros[0].x = 200;
Heros[0].y = 20;
Heros[0].menuChoices = ["Attack","Skill","Item","Defend","Run"];
Heros[1] = new character("Heidi", 103, 64, 6,25,15,5);
Heros[1].battlepic = LoadImage("Heidi.png");
Heros[1].battlepicwhite = LoadImage("HeidiWhite.png");
Heros[1].picFlip = LoadImage("HeidiFlipped.png");
Heros[1].x = 200;
Heros[1].y = 45;
Heros[1].menuChoices = ["Attack","Pokemon","Item","Aquire","Run"]

var playerParty = new Array();
playerParty[0] = Heros[0];
playerParty[1] = Heros[1];


function levelUp(who)
{
	if(who==0){
		playerParty[who].atk += Math.floor(Math.random()*4+1);
		playerParty[who].def += Math.floor(Math.random()*3+1);
		playerParty[who].maxhp += Math.floor(Math.random()*10+1);
		playerParty[who].hp = playerParty[who].maxhp;
		playerParty[who].spd += Math.floor(Math.random()*3+1);
		playerParty[who].maxsp += Math.floor(Math.random()*5+1);
		playerParty[who].sp = playerParty[who].maxsp;
	}
	else {
		playerParty[who].atk += Math.floor(Math.random()*2+1);
		playerParty[who].def += Math.floor(Math.random()*3+1);
		playerParty[who].maxhp += Math.floor(Math.random()*10+1);
		playerParty[who].hp = playerParty[who].maxhp;
		playerParty[who].spd += Math.floor(Math.random()*4+1);
		playerParty[who].maxsp += Math.floor(Math.random()*10+1);
		playerParty[who].sp = playerParty[who].maxsp;
	}
}


var Enemies = new Array();
Enemies[0] = new character("Rattata", 20, 25, 10, 5, 5, 5);
Enemies[0].x = 40;
Enemies[0].y = 40;
Enemies[0].exp = 4;
Enemies[0].NeededExp = 1;
Enemies[0].atbMax = 450;
Enemies[0].enemy = true;
Enemies[0].battlepic = LoadImage("Enemies/Rattata.png");
Enemies[0].bits = 18;


var EnemyGroup = new Array();
EnemyGroup[0] = new Object();
EnemyGroup[0].pk1 = Enemies[0].clone();//EnemyGroup[0].pk1.name
EnemyGroup[0].nameL1 = "Rattata";
EnemyGroup[0].nameL2 = "";
EnemyGroup[0].nameL3 = "";
EnemyGroup[0].openingMessage = "Rattata wants to fight!";