//menu.js
var menuWS = LoadWindowStyle("BigWindow.rws");
var menuF = LoadFont("menufont.rfn");



//////////////////////////////////////////
//START OF MAIN MENU//////////////////////
//////////////////////////////////////////
var mmCount = 0;
var selectingPlayer = false;
var sp = 0;

function mainMenu()
{
	mmCount = 0;
	sp = 0;
	while(true){
		menuWS.drawWindow(165,15,70,80);
		menuWS.drawWindow(165,120,70,25);
		talkfont.drawText(167,120,"Bits " + player.gold);
		talkfont.drawText(174,133,"99:99:99");
		
		menuF.drawText(167,17,"Items");
		menuF.drawText(167,32,"Skill");
		menuF.drawText(167,47,"Equipment");
		menuF.drawText(167,62,"Status");
		menuF.drawText(167,77,"Close");
		
		winSelect.drawWindow(165,(mmCount*15)+16,70,14);
		
		for(i=0;i<playerParty.length;i++){
			menuWS.drawWindow(10,(i*50)+15,140,30);
			playerParty[i].picFlip.blit(12,(i*50)+10);
			talkfont.drawText(45,(i*50)+18,playerParty[i].name);
			talkfont.drawText(45,(i*50)+30,"Lv" + playerParty[i].lvl);
			talkfont.drawText(80,(i*50)+18,"HP " + playerParty[i].hp + "/" + playerParty[i].maxhp);
			talkfont.drawText(80,(i*50)+30,"SP " + playerParty[i].sp + "/" + playerParty[i].maxsp);
		}
		
		if(selectingPlayer){
			winSelect.drawWindow(10,(sp*50)+15,140,30);
		}
		
		menuWS.drawWindow(10,120,140,25);
		talkfont.drawText(16,121,"Location");
		greenFont.drawText(16,131,player.location);
		
		FlipScreen();
		
		switch(GetKey()){
			
			case KEY_DOWN:
				if(mmCount < 4 && !selectingPlayer){
					mmCount++;
				}
				else{
					if(sp < playerParty.length-1) sp++;
				}
			break;
			
			case KEY_UP:
				if(mmCount > 0 && !selectingPlayer){
					mmCount--;
				}
				else{
					if(sp > 0) sp--;
				}
			break;
			
			case KEY_CTRL:
				if(mmCount == 4 && !selectingPlayer){
					return;
				}
				if(mmCount == 1){
					selectingPlayer = true;
				}
				if(mmCount == 0) itemsMenu();
			break;
			
			case KEY_ALT:
				if(selectingPlayer){
					selectingPlayer = false;
				}
				else return;
			break;
		}
	}
}
////////////////////END OF MAIN MENU////////////////////////




///////////////////////////////////////////
/////////START OF ITEMS MENU///////////////
///////////////////////////////////////////
var initSel = 0;
var initSelTrue = true;
var itemSelect = false;

var topSel = 0;
var itemSel = 0;


function itemsMenu()
{
	initSel = 0;
	initSelTrue = true;
	itemSel = 0;
	while(true){
		menuWS.drawWindow(10,10,220,15);
		menuWS.drawWindow(10,40,220,15);
		menuWS.drawWindow(10,70,220,80);
		
		talkfont.drawText(34,13,"USE");
		talkfont.drawText(104,13,"SORT");
		talkfont.drawText(174,13,"KEY");
		
		if(itemSelect) talkfont.drawText(13,43,inventory[itemSel].desc);
		
		winSelect.drawWindow((initSel*70)+25,11,40,14);
		
		for(i=0;i<5 && (i+topSel) < inventory.length;i++){
			menuFont.drawText(55,(i*15)+73,inventory[i+topSel].name);
			menuFont.drawText(165,(i*15)+73,inventory[i+topSel].amount);
		}
		
		if(itemSelect){
			winSelect.drawWindow(50,((itemSel-topSel)*15)+71,130,14);
		}
		
		FlipScreen();
		
		switch(GetKey()){
			case KEY_RIGHT:
				if(initSel < 2 && initSelTrue) initSel++;
			break;
			case KEY_LEFT:
				if(initSel > 0 && initSelTrue) initSel--;
			break;
			case KEY_ALT:
				if(initSelTrue) return;
				if(itemSelect) {itemSelect = false; initSelTrue = true;}
			break;
			case KEY_CTRL:
				if(initSel == 0 && initSelTrue) {initSelTrue = false; itemSelect = true;}
			break;
			case KEY_DOWN:
				if(itemSelect && itemSel < inventory.length-1) { itemSel++ }
				if(itemSel >= topSel+5) topSel++;
			break;
			case KEY_UP:
				if(itemSelect && itemSel > 0) itemSel--;
				if(itemSel < topSel) topSel--;
			break;
		}
	}
}