//items.js

function Item(name,cost,desc){
	this.name = name;
	this.cost = cost;
	this.sell = cost/2;
	this.desc = desc;
	this.amount = 0;
}

var items = new Array();
items[0] = new Item("Antidote",100,"Cures poison status.");
items[1] = new Item("Tent",500,"Heals everything; Can only be used at Save Points.");
items[2] = new Item("Echo Screen", 120, "Cures mute status.");
items[3] = new Item("Elixer",400,"Heals HP and SP to Max.");
items[4] = new Item("Ether",220,"Heals a small amount of SP.");
items[5] = new Item("Eye Drop",110,"Cures Blindness.");
items[6] = new Item("Soft",140,"Cures stone status.");
items[7] = new Item("Hi-Ether", 400, "Cures a large amount of SP.");
items[8] = new Item("Hi-Potion",375, "Cures a large amount of HP.");
items[9] = new Item("Holy Water", 160, "Cures Zombie status.");
items[10] = new Item("Megalixer", 5000, "Heals everything; Entire Party.");
items[11] = new Item("Mega Potion", 1000, "Heals large amount of HP; Entire Party.");
items[12] = new Item("Phoenix Claw", 250, "Bring one ally back to life.");
items[13] = new Item("Potion",200,"Heal a small amount of HP.");
items[14] = new Item("Remedy",275,"Heal all status ailments.");
items[15] = new Item("X-Potion",750,"Heals max HP.");


var inventory = new Array();


function addItem(name, amount)//name is actually the array element
{
//see if the player has the item already
for (i = 0; i < inventory.length; i++)
{
	//If the current checked item is the same as the item in the list...
	if (name == inventory[i])
	{
		inventory[i].amount += amount;
		
		//If amount goes above 100...
		if (inventory[i].amount > 99)
		{
			inventory[i].amount = 99;
			text("You can't carry any more of this item!",true);
		}
	return;
	}
}
inventory.splice(inventory.length, 0, name);
inventory[inventory.length - 1].amount += amount;
}