//text.js

var isdisplayed = false;
var arrowDisplayed = 0;
var blinkRate = 250;
var Tarrow = LoadImage("TArrow.PNG");
var Standard = LoadWindowStyle("Standard.rws");
var talkfont = LoadFont("talkfont.rfn");
var TextSpeed = 1;
var signwin = LoadWindowStyle("leafwindow.rws");
var selectionBox = LoadWindowStyle("MenuRing.rws");


/*
--------------------------------------------------
Person - Person Talking
--------------------------------------------------
*/
function text(txt,more)
{
	ClearKeyQueue();
	for (i=0;i<txt.length*10;i += TextSpeed)
	{
		RenderMap();
		Standard.drawWindow(13,130,GetScreenWidth()-25,20);
		talkfont.drawTextBox(13,129,GetScreenWidth()-25,30,0,txt.substr(0,i/8));
		FlipScreen();
		ClearKeyQueue();
	}
     // Change this to whatever you need
	while(!IsKeyPressed(KEY_CTRL))
	{
		RenderMap();
		Standard.drawWindow(13,130,GetScreenWidth()-25,20);
		talkfont.drawTextBox(13,129,GetScreenWidth()-25,30,0,txt.substr(0,i/8));
		arrowDisplayed = ++arrowDisplayed % blinkRate;
		if(arrowDisplayed < Math.floor(blinkRate / 2) && more == true)
		{
			// change x and y to the coordinates for your arrow
			Tarrow.blit(200, 150);   
		}
		else
		{
			isdisplayed = false
		}
		FlipScreen();
	}
	ClearKeyQueue();
}

/*
----------------------------------------------------
Talking to signs or other objects
----------------------------------------------------
*/
function sign(txt,poketips)
{
	ClearKeyQueue();
	for (i=0;i<txt.length*10;i += TextSpeed)
	{
	UpdateMapEngine();
	RenderMap();
	signwin.drawWindow(14,128,GetScreenWidth()-28,20);//y must be 190 or 10...
	talkfont.drawTextBox(14,126,GetScreenWidth()-28,30,0,txt.substr(0,i/8));
	
	FlipScreen();
	ClearKeyQueue();
	}
	
	while(!IsKeyPressed(KEY_CTRL)) 
	{
	UpdateMapEngine();
	RenderMap();
	signwin.drawWindow(14,128,GetScreenWidth()-28,20);//y must be 190 or 10...
	talkfont.drawTextBox(14,126,GetScreenWidth()-28,30,0,txt);
	if(poketips){
		signwin.drawWindow(14,10,120,15);
		talkfont.drawText(20,11,"Tips found: 2/44");
	}
	FlipScreen();
	ClearKeyQueue();
}
}

/*
-----------------------------------------------------------------------------------------------
Got a question? Use this to answer it, the yes/no choice box
-----------------------------------------------------------------------------------------------
*/
var ChoiceBoxChoice

function YesNoChoice(question,choice1,choice2,saving)
{
	if(saving == undefined){
		saving = false;
	}
	var pick = 1;
	var done = false;
	while (!done)
	{
	RenderMap();
	Standard.drawWindow(10,140,GetScreenWidth()-20,10);
	menuWindow.drawWindow(161,100,60,34);
	if(saving){
		menuWindow.drawWindow(10,10,100,80);
		talkfont.drawText(12,12,"Player: " + Hero.name);
		talkfont.drawText(12,27,"Badges: 1");
		talkfont.drawText(12,42,"Pokedex: 3");
		talkfont.drawText(12,57,"Time: 00:05");
	}
	if (pick == 1)
	{
		selectionBox.drawWindow(161,102,50,14);
		menuFont.drawText(162,104,choice1);
		menuFont.drawText(162,121,choice2);
	}
	else if (pick == 2)
	{
		selectionBox.drawWindow(161,119,50,14);
		menuFont.drawText(162,104,choice1);
		menuFont.drawText(162,121,choice2);
	}
	
	talkfont.drawText(9,140,question);
	
	FlipScreen();
	
	ClearKeyQueue();
	switch(GetKey()) {
		case KEY_CTRL: {
			if (pick == 1)  {
				ChoiceBoxChoice = 1;
				done = true;
				}
			else if (pick == 2) {
				ChoiceBoxChoice = 2;
				done = true;
				}
				break;
			}
		case KEY_UP: {
			pick ++;
			if (pick > 2) { pick = 1 }
			break;
			}
		case KEY_DOWN: {
			pick --;
			if (pick < 1) { pick = 2 }
			break;
		}
	}
}
}



function FacePlayer(person)
{	
	if (person == undefined) var person_to_turn = GetCurrentPerson();
	else var person_to_turn = person;
	
	var InputPerson = GetInputPerson();

	if (GetPersonDirection(InputPerson) == "north")
		SetPersonDirection(person_to_turn, "south");
	
	else if (GetPersonDirection(InputPerson) == "south")
		SetPersonDirection(person_to_turn, "north");
	
	else if (GetPersonDirection(InputPerson) == "east")
		SetPersonDirection(person_to_turn, "west");
	
	else if (GetPersonDirection(InputPerson) == "west")
		SetPersonDirection(person_to_turn, "east");
}


function RandomFace(who)
{
	if(Math.random() < .01){
		var movements = new Array("east","north","south","west",GetPersonDirection(who));
		var i = Math.floor(Math.random()*5);
		SetPersonDirection(who,movements[i]);
	}
}